use crate::{async_trait, error::Error, traits::CacheDriver, CacheResult};

pub struct Null;

pub fn new() -> Box<dyn CacheDriver> {
    Box::new(Null {})
}

#[async_trait]
impl CacheDriver for Null {
    async fn has(&self, _key: &str) -> CacheResult<bool> {
        Err(Error::Message("Operation not supported by null cache".into()))
    }

    async fn get(&self, _key: &str) -> CacheResult<Option<String>> {
        Ok(None)
    }

    async fn insert(&self, _key: &str, _value: &str) -> CacheResult<()> {
        Err(Error::Message("Operation not supported by null cache".into()))
    }

    async fn remove(&self, _key: &str) -> CacheResult<()> {
        Err(Error::Message("Operation not supported by null cache".into()))
    }
    async fn clear(&self) -> CacheResult<()> {
        Err(Error::Message("Operation not supported by null cache".into()))
    }
}
